/*
 * ws2812test.c
 *
 * Created: 12.12.2012 00:02:22
 *  Author: adrock
 */ 


#define F_CPU 16000000

#include <avr/io.h>
#include <util/delay.h>
#include <avr/pgmspace.h>
#include <stdlib.h>

#include "ws2812.h"
#include "gammacorrection.h"

#define NUMLEDS 5

#define PUTRGB(D,I,R,G,B) {*(D+((I)*3)+1)=R; *(D+((I)*3))=G; *(D+((I)*3)+2)=B; }
#define FADE(D,V) ({ uint8_t I; for(I=0; I<sizeof(D); I++) if(D[I] > V) D[I] -= V; else D[I] = 0; })

static uint8_t MyData[NUMLEDS*3];

static const uint8_t PROGMEM GammaTable[] = GCN_TABLE7TO8;

int main(void)
{
    uint8_t I, J, R, G, B;

    // Init driver stuff
 
    WS_init();
    
    // Do some test patterns
    
    while(1) {
/*
        for(R=0; R<128; R++) {
            for(G=0; G<128; G++) {
                for(B=0; B<128; B++) {
                    for(I=0; I<NUMLEDS; I++) {
                        PUTRGB(MyData, I, R, G, B);
                    }
                    WS_putG(MyData, sizeof(MyData), GammaTable)                    ;
                    _delay_ms(20);
                }
            }
        }
  */      
        R=rand()&0x7f;
        G=rand()&0x7f;
        B=rand()&0x7f;
        for(I=0; I<NUMLEDS; I++) {
            PUTRGB(MyData, I, R, G, B);
            for(J=0; J<10; J++) {
                WS_putG(MyData, sizeof(MyData), GammaTable);
                _delay_ms(20);
                FADE(MyData, 1);
            }            
        }        
        for(I=5; I>0; I--) {
            PUTRGB(MyData, I-1, R, G, B);
            for(J=0; J<10; J++) {
                WS_putG(MyData, sizeof(MyData), GammaTable);
                _delay_ms(20);
                FADE(MyData, 1);
            }            
        }
    }    
}